% This demo illustrates the use of the function tvboa_debluring.

for i=1:3
    if i==1
        
        imagem='cameraman';
        img=double(imread('cameraman.tif'));
        % % zero noise image (not necessary)
        img=img-mean(img(:));


        % Blur Kernel
        h=ones(9)/81;
        sigma=0.56;  %BSNR = 40 dB
        % TV penalty parameter (just an heuristc)
        lambda=0.064*sigma^2;
    elseif i==2
        imagem='phantom';
        img=256*phantom(256);
        % % zero noise image (not necessary)
        img=img-mean(img(:));


        % Blur Kernel
        h=ones(9)/81;
        sigma=0.4;  %BSNR = 40 dB
        % TV penalty parameter (just an heuristc)
        lambda=0.064*sigma^2;
    else
        imagem='lena';
        img=double(imread('lena_256.gif'));
        % % zero noise image (not necessary)
        img=img-mean(img(:));


        % Blur Kernel
        h=[1 4 6 4 1]'*[1 4 6 4 1]/256;
        sigma=7;  %BSNR = 40 dB
        % TV penalty parameter (just an heuristc)
        lambda=0.064*sigma^2;
    end


% Blured noisy image
img_noisy=conv2c(img,h)+sigma*randn(size(img));

% Conjugate Gradient method
img_estimated=tvmm_debluring(img_noisy,h,lambda,'info_energyi','no','info_energyo','yes','image',img, ...
    'cg_iter',200,'boa_iter',10,'info_ISNRo','yes','info_ISNRi','no','displayIm','yes');

return;

filename=strcat('data/',imagem,'_dados');

save(filename,'img','img_noisy','img_estimated');

%Imagem original

figure(1);imagesc(img);colormap gray;
filename=strcat('data/',imagem,'_imagem_original');
print(1, '-depsc2', filename);


figure(2);imagesc(img_noisy);colormap gray;
filename=strcat('data/',imagem,'_imagem_noisy');
print(2', '-depsc2', filename);

figure(3);imagesc(img_estimated);colormap gray;
filename=strcat('data/',imagem,'_imagem_restaurada');
print(3', '-depsc2', filename);

%Imagem desfocada
%Imagem restaurada
end
